use organic::types::StandardProperties;

use super::macros::intermediate;

use super::IObject;
use crate::error::CustomError;

#[derive(Debug, Clone)]
pub(crate) struct IRegularLink {
    pub(crate) raw_link: String,
    pub(crate) children: Vec<IObject>,
    pub(crate) post_blank: organic::types::PostBlank,
}

intermediate!(
    IRegularLink,
    &'orig organic::types::RegularLink<'parse>,
    original,
    intermediate_context,
    {
        let children = {
            let mut ret = Vec::new();
            for obj in original.children.iter() {
                ret.push(IObject::new(intermediate_context.clone(), obj).await?);
            }
            ret
        };
        Ok(IRegularLink {
            raw_link: original.get_raw_link().into_owned(),
            children,
            post_blank: original.get_post_blank(),
        })
    }
);
